UNIT MP3MAIN;
(* Hauptsteuerung fr den MP3-Player *)
INTERFACE
PROCEDURE MainLoop;
IMPLEMENTATION
USES MP3PLS,MP3PUMP,MP3UICOM,MP3USER,crt;

CONST usNormal = 1;
      usTitleSel = 2;
      usArtistSel = 3;
      usPLSNameNew = 4;
      usPLSNameLoad = 5;
      usPLSSelect = 6;
      usPLSTitleDel = 7;
      usPLSOrder = 8;
      usPLSDelete = 9;

      VersionTxt = '1.10 (2.8.1999)';


TYPE ShuffleTable=ARRAY[0..8191] OF BYTE; (* Struktur zur Verwaltung bereits
                                             gespielter Titel *)
     PShuffleTable = ^ShuffleTable;

PROCEDURE MainLoop;
(* Hauptschleife *)
VAR CurUserState: BYTE;
    shutdown: BOOLEAN;
    stopped,paused: BOOLEAN;
    shuffle: BOOLEAN;
    timeleft: BOOLEAN;
    ctitle,cartist: STRING;
    ctrack: WORD;
    cmin,csec,nmin,nsec: WORD;
    ev: CHAR;
    tmp,tmp2: STRING;
    bitrate,samplerate: WORD;
    mpeg,layer: BYTE;
    statusfile: TEXT;
    shuftab: PShuffleTable;

  PROCEDURE ClearShufTab; (* ShuffleTabelle lschen *)
  VAR zae: WORD;
  BEGIN
    FOR zae:=0 TO 8191 DO shuftab^[zae]:=0;
  END;
  FUNCTION ShufTitlePlayed(t: WORD): BOOLEAN;
  BEGIN
    ShufTitlePlayed:=(shuftab^[t DIV 8] AND (1 SHL (t MOD 8)))<>0;
  END;
  PROCEDURE ShufMarkTitle(t: WORD);
  BEGIN
    shuftab^[t DIV 8]:=shuftab^[t DIV 8] OR (1 SHL (t MOD 8));
  END;
  FUNCTION GetNextAvailTrack: STRING;
  (* Dateiname des nchsten Verfgbaren Tracks holen *)
  VAR octr: WORD;
      cnt: WORD;
  BEGIN
    IF shuffle THEN BEGIN
      tmp:='';
      octr:=RANDOM(PlaylistGetTrackCount);
      cnt:=0;
      WHILE (cnt<PlaylistGetTrackCount) AND ShufTitlePlayed(octr+1) DO BEGIN
        INC(octr);
        IF octr>=PlaylistGetTrackCount THEN octr:=0;
        INC(cnt);
      END;
      IF cnt>=PlaylistGetTrackCount THEN BEGIN
        ClearShufTab;
        octr:=RANDOM(PlaylistGetTrackCount);
      END;
      ctrack:=octr;
      REPEAT
        INC(ctrack);
        IF PlaylistGetTrack(ctrack,ctitle,cartist) THEN BEGIN
          tmp:=GetTrackPath(ctitle,cartist);
        END ELSE ctrack:=0;
      UNTIL (tmp<>'') OR (ctrack=octr);
      ShufMarkTitle(ctrack);
      GetNextAvailTrack:=tmp;
      EXIT;
    END;
    octr:=ctrack;
    tmp:='';
    REPEAT
      INC(ctrack);
      IF PlaylistGetTrack(ctrack,ctitle,cartist) THEN BEGIN
        tmp:=GetTrackPath(ctitle,cartist);
        IF console THEN BEGIN
          Gotoxy(1,18);
          WRITE('Suche: '+cartist+' - '+ctitle);
          Gotoxy(1,19);
          WRITE('Datei: '+tmp);
        END;
      END ELSE ctrack:=0;
    UNTIL (ctrack=octr) OR (tmp<>'');
    GetNextAvailTrack:=tmp;
  END;
  FUNCTION GetLastAvailTrack: STRING;
  (* Dateiname des vorigen verfgbaren Tracks holen *)
  VAR octr: WORD;
  BEGIN
    IF shuffle THEN BEGIN
      GetLastAvailTrack:=GetNextAvailTrack;
      EXIT;
    END;
    octr:=ctrack;
    tmp:='';
    REPEAT
      DEC(ctrack);
      IF ctrack=0 THEN ctrack:=PlaylistGetTrackCount;
      IF PlaylistGetTrack(ctrack,ctitle,cartist) THEN
        tmp:=GetTrackPath(ctitle,cartist);
    UNTIL (ctrack=octr) OR (tmp<>'');
    GetLastAvailTrack:=tmp;
  END;
  FUNCTION GetTrackInfo: STRING;
  VAR titmp: string;
  BEGIN
    titmp:=IntToStr(ctrack)+'/'+IntToStr(PlaylistGetTrackCount);
    IF length(titmp)>6 THEN begin
      titmp:=IntToStr(ctrack);
      IF length(titmp)<5 then titmp:='('+titmp+')';
    end;
    GetTrackInfo:=titmp;
  END;

BEGIN
  New(shuftab);
  ClearShufTab;
  UI_Ready;
  WRITELN('MP3 Player / PUMP Steuersystem');
  WRITELN('(c) Tassilo Heeg 6.7.1999');
  IF FileExists('C:\INDEX\STATUS.INI') THEN BEGIN
    (* letzten Track wieder laden *)
    ASSIGN(statusfile,'C:\INDEX\STATUS.INI');
    RESET(statusfile);
    ctrack:=0;
    IF NOT EOF(statusfile) THEN READLN(statusfile,ctrack);
    tmp:='SHUFFLE=OFF';
    IF NOT EOF(statusfile) THEN READLN(statusfile,tmp);
    shuffle:=tmp='SHUFFLE=ON';
    tmp:='TIMELEFT=OFF';
    IF NOT EOF(statusfile) THEN READLN(statusfile,tmp);
    timeleft:=tmp='TIMELEFT=ON';
    CLOSE(statusfile);
    stopped:=ctrack<>0;
    paused:=FALSE;
  END ELSE BEGIN
    ctrack:=1;
    stopped:=TRUE;
    paused:=FALSE;
    shuffle:=FALSE;
    timeleft:=FALSE;
  END;
  PlaylistGetTrack(ctrack,ctitle,cartist);
  shutdown:=FALSE;

  CurUserState:=usNormal;
  ui_TrackInfo1('');
  ui_TrackInfo2('Sys v'+VersionTxt);
  ui_TrackInfo3(GetTrackInfo);
  ui_TimeInfo('--:--',shuffle);
  InitMAS;

  IF NOT stopped THEN BEGIN
    tmp:=GetTrackPath(ctitle,cartist);
    IF tmp<>'' THEN BEGIN
      OpenFile(tmp);
      ui_TrackInfo1(cartist);
      ui_TrackInfo2(ctitle);
      ui_TrackInfo3(GetTrackInfo);
      stopped:=FALSE;
      Play;
    END ELSE BEGIN
      stopped:=TRUE;
    END;
  END;


  REPEAT
    DataCheck;
    IF UI_GetEvent(ev) THEN BEGIN
      (* Ereignis eingetreten *)
      CASE CurUserState OF
        usNormal: BEGIN
          (* Normaler Player-Betrieb *)
          CASE ev OF
            '#': IF NOT stopped THEN BEGIN (* Stop *)
                   stopped:=TRUE;
                   cmin:=0;
                   csec:=60;
                   Stop;
                   ui_TrackInfo1('');
                   ui_TrackInfo2('');
                   ui_TrackInfo3(GetTrackInfo);
                   ui_TimeInfo('--:--',shuffle);
                   ClearShufTab;
                 END;
            '*': BEGIN (* Play *)
                   IF stopped THEN BEGIN
                     ui_TrackInfo1('Datei wird gesucht...');
                     ui_TrackInfo2('');
                     ui_TrackInfo3(GetTrackInfo);
                     ui_TimeInfo('',shuffle);
                     tmp:=GetTrackPath(ctitle,cartist);
                     IF tmp='' THEN tmp:=GetNextAvailTrack;
                     IF tmp<>'' THEN BEGIN
                       OpenFile(tmp);
                       ui_TrackInfo1(cartist);
                       ui_TrackInfo2(ctitle);
                       ui_TrackInfo3(GetTrackInfo);
                       stopped:=FALSE;
                       paused:=FALSE;
                       Play;
                     END ELSE BEGIN
                       ui_TrackInfo1('Keine Datei verfgbar!');
                       ui_TrackInfo3('');
                     END
                   END ELSE IF paused THEN BEGIN
                     paused:=FALSE;
                     Play;
                   END ELSE BEGIN
                     (* nicht Pause, nicht Stop... *)
                     timeleft:=NOT timeleft;
                     csec:=60;
                   END;
                 END;
            '"': BEGIN (* Pause *)
                   IF NOT stopped THEN IF NOT paused THEN BEGIN
                     Pause;
                     paused:=TRUE;
                     csec:=60;
                   END;
                 END;
            'R': BEGIN (* Next Track *)
                   ui_TrackInfo1('Datei wird gesucht...');
                   ui_TrackInfo2('');
                   ui_TimeInfo('',shuffle);
                   tmp:=GetNextAvailTrack;
                   ui_TrackInfo3(GetTrackInfo);
                   IF NOT stopped THEN BEGIN
                     Stop;
                     IF tmp<>'' THEN BEGIN
                       OpenFile(tmp);
                       ui_TrackInfo1(cartist);
                       ui_TrackInfo2(ctitle);
                       ui_TrackInfo3(GetTrackInfo);
                       stopped:=FALSE;
                       IF NOT paused THEN Play ELSE Pause;
                     END ELSE BEGIN
                       ui_TrackInfo1('Keine Datei verfgbar!');
                       ui_TrackInfo3('');
                       stopped:=TRUE;
                     END;
                   END ELSE BEGIN
                     ui_TrackInfo1(cartist);
                     ui_TrackInfo2(ctitle);
                     ui_TrackInfo3(GetTrackInfo);
                     ui_TimeInfo('--:--',shuffle);
                   END;
                 END;
            'L': BEGIN (* Last Track *)
                   IF (csec<10) AND (cmin=0) THEN BEGIN
                     ui_TrackInfo1('Datei wird gesucht...');
                     ui_TrackInfo2('');
                     tmp:=GetLastAvailTrack;
                     ui_TrackInfo3(GetTrackInfo);
                   END ELSE BEGIN
                     csec:=0;
                     tmp:=GetTrackPath(ctitle,cartist);
                   END;
                   ui_TimeInfo('',shuffle);
                   IF NOT stopped THEN BEGIN
                     Stop;
                     IF tmp<>'' THEN BEGIN
                       OpenFile(tmp);
                       ui_TrackInfo1(cartist);
                       ui_TrackInfo2(ctitle);
                       ui_TrackInfo3(GetTrackInfo);
                       stopped:=FALSE;
                       IF NOT paused THEN Play ELSE Pause;
                     END ELSE BEGIN
                       ui_TrackInfo1('Keine Datei verfgbar!');
                       ui_TrackInfo3('');
                       stopped:=TRUE;
                     END;
                   END ELSE BEGIN
                     ui_TrackInfo1(cartist);
                     ui_TrackInfo2(ctitle);
                     ui_TrackInfo3(GetTrackInfo);
                     ui_TimeInfo('--:--',shuffle);
                   END;
                 END;
            '>': BEGIN (* Suchlauf nach vorn *)
                   Skip_FF;
                 END;
            '<': BEGIN (* Suchlauf nach vorn *)
                   Skip_REW;
                 END;
            #255: shutdown:=TRUE;
            #140..#150: BEGIN (* Laufwerk x neu erkennen *)
                   stopped:=TRUE;
                   cmin:=0;
                   csec:=60;
                   Stop;
                   ui_EnterExclusiveMode;
                   IF ORD(ev)>140 THEN
                     ReScanDrive(ORD(ev)-141)
                   ELSE
                     ReScanDrives;
                   ui_ExitExclusiveMode;
                   ui_TrackInfo1('');
                   ui_TrackInfo2('');
                   ui_TrackInfo3('');
                   ui_TimeInfo('--:--',shuffle);
                   ClearShufTab;
                 END;
            #130:BEGIN (* Titel zur Playliste zufgen *)
                   ui_EnterExclusiveMode;
                   TitleSel_Show;
                   CurUserState:=usTitleSel;
                 END;
            #131:BEGIN (* Titel zur Playliste zufgen *)
                   ui_EnterExclusiveMode;
                   ArtistSel_Show;
                   CurUserState:=usArtistSel;
                 END;
            #132:BEGIN (* Titel von Playliste lschen *)
                   ui_EnterExclusiveMode;
                   PLSTitleSel_Show;
                   CurUserState:=usPLSTitleDel;
                 END;
            #133:BEGIN (* Titel anordnen *)
                   ui_EnterExclusiveMode;
                   PLSOrder_Show;
                   CurUserState:=usPLSOrder;
                 END;
            #134:BEGIN (* PLS lschen *)
                   ui_EnterExclusiveMode;
                   PLSDel_Show;
                   CurUserState:=usPLSDelete;
                 END;
            #135:BEGIN (* Toggle Shuffle *)
                   ui_ExitExclusiveMode;
                   shuffle:=NOT shuffle;
                   IF stopped THEN
                     ui_TimeInfo('--:--',shuffle)
                   ELSE
                     csec:=60;
                 END;
            #136:BEGIN (* NetSync*)
                   stopped:=TRUE;
                   cmin:=0;
                   csec:=60;
                   Stop;
                   ui_EnterExclusiveMode;
                   NetworkSync;
                   ui_ExitExclusiveMode;
                   ui_TrackInfo1('');
                   ui_TrackInfo2('');
                   ui_TrackInfo3('');
                   ui_TimeInfo('--:--',shuffle);
                   ClearShufTab;
                 END;
            #137:BEGIN (* Software-Upgrade *)
                   ASSIGN(statusfile,'C:\INDEX\STATUS.INI');
                   REWRITE(statusfile);
                   WRITELN(statusfile,ctrack);
                   IF shuffle THEN
                     WRITELN(statusfile,'SHUFFLE=ON')
                   ELSE
                     WRITELN(statusfile,'SHUFFLE=OFF');
                   CLOSE(statusfile);
                   ExitMas;
                   Dispose(shuftab);
                   halt(234);
                 END;
            #129:BEGIN (* neue Playliste *)
                   stopped:=TRUE;
                   cmin:=0;
                   csec:=60;
                   Stop;
                   IF PlaylistChanged THEN BEGIN
                     ui_EnterExclusiveMode;
                     EnterName_Show(PlaylistGetName);
                     CurUserState:=usPLSNameNew;
                   END ELSE BEGIN
                     ui_ExitExclusiveMode;
                     CreateNewPlaylist;
                     cartist:=''; ctitle:=''; ctrack:=1;
                     ui_TrackInfo1('');
                     ui_TrackInfo2('');
                     ui_TrackInfo3('');
                     ui_TimeInfo('--:--',shuffle);
                     ClearShufTab;
                   END;
                 END;
            #128:BEGIN (* Playliste laden *)
                   stopped:=TRUE;
                   cmin:=0;
                   csec:=60;
                   Stop;
                   IF PlaylistChanged THEN BEGIN
                     ui_EnterExclusiveMode;
                     EnterName_Show(PlaylistGetName);
                     CurUserState:=usPLSNameLoad;
                   END ELSE BEGIN
                     ui_EnterExclusiveMode;
                     PLSSel_Show;
                     CurUserState:=usPLSSelect;
                   END;
                 END;

          END;
        END;
        usTitleSel: BEGIN
          CASE ev OF
            'U','D','R','L','>','<','1','2','3','4': TitleSel_Key(ev);
            #27: BEGIN
                   ui_ExitExclusiveMode;
                   CurUserState:=usNormal;
                   ui_TrackInfo1(cartist);
                   ui_TrackInfo2(ctitle);
                   ui_TrackInfo3(GetTrackInfo);
                   csec:=60;
                   ui_TimeInfo('--:--',shuffle);
                   ClearShufTab;
                 END;
            #13: BEGIN
                   (* Titel Gewhlt *)
                   TitleSel_GetSelection(tmp,tmp2);
                   IF (tmp<>'') OR (tmp2<>'') THEN BEGIN
                     (* Title gewhlt *)
                     UI_GOTOXY(1,2);
                     UI_SetColors(ui_clWhite,ui_clCyan);
                     UI_WRITE('Titel hinzugefgt       ');
                     IF stopped THEN BEGIN
                       ctitle:=tmp; cartist:=tmp2;
                       PlaylistAddTitle(ctitle,cartist);
                       ui_TrackInfo1(cartist);
                       ui_TrackInfo2(ctitle);
                       csec:=60;
                       ui_TimeInfo('--:--',shuffle);
                       ctrack:=1;
                       tmp:=GetLastAvailTrack;
                       ui_TrackInfo3(GetTrackInfo);
                       Stop;
                       ClearShufTab;
                       IF tmp<>'' THEN BEGIN
                         OpenFile(tmp);
                         ui_TrackInfo1(cartist);
                         ui_TrackInfo2(ctitle);
                         ui_TrackInfo3(GetTrackInfo);
                         stopped:=FALSE;
                         paused:=FALSE;
                         Play;
                       END ELSE BEGIN
                         ui_TrackInfo1('Keine Datei verfgbar!');
                         ui_TrackInfo3('');
                         stopped:=TRUE;
                       END;
                     END ELSE BEGIN
                       (* nicht unterbrechen *)
                       PlaylistAddTitle(tmp,tmp2);
                       ui_TrackInfo3(GetTrackInfo);
                     END;
                     TitleSel_ConfirmSelection;
                   END ELSE BEGIN
                     (* keinen Titel in der Auswahl => wie ESC *)
                     ui_ExitExclusiveMode;
                     CurUserState:=usNormal;
                     ui_TrackInfo1(cartist);
                     ui_TrackInfo2(ctitle);
                     ui_TrackInfo3(GetTrackInfo);
                     csec:=60;
                     ui_TimeInfo('--:--',shuffle);
                     ClearShufTab;
                   END;
                 END;
            '*': BEGIN (* Play *)
                   TitleSel_GetSelection(tmp,tmp2);
                   IF (tmp<>'') OR (tmp2<>'') THEN BEGIN
                     Stop; (* fr alle Flle *)
                     TitleSel_GetSelection(ctitle,cartist);
                     tmp:=GetTrackPath(ctitle,cartist);
                     IF tmp<>'' THEN BEGIN
                       OpenFile(tmp);
                       stopped:=FALSE;
                       paused:=FALSE;
                       Play;
                       GetStreamInfo(bitrate,samplerate,mpeg,layer);
                       tmp:='MP '+IntToStr(mpeg)+' L'+IntToStr(layer)
                           +' '+IntToStr(samplerate DIV 1000)+'kHz '
                           +IntToStr(bitrate)+'kbit/s ';
                       UI_GOTOXY(1,2);
                       UI_SetColors(ui_clWhite,ui_clBlack);
                       UI_WRITE(tmp);
                       ui_TrackInfo1(cartist);
                       ui_TrackInfo2(ctitle);
                       ui_TrackInfo3('');
                     END;
                   END;
                 END;
            '"': BEGIN (* Pause *)
                   IF NOT stopped THEN IF NOT paused THEN BEGIN
                     Pause;
                     paused:=TRUE;
                     csec:=60;
                   END;
                 END;
            '#': IF NOT stopped THEN BEGIN (* Stop *)
                   stopped:=TRUE;
                   cmin:=0;
                   csec:=60;
                   Stop;
                 END;
            #255:shutdown:=TRUE;
          END; (* CASE *)
        END;
        usArtistSel: BEGIN
          CASE ev OF
            'U','D','R','L','>','<','1','2','3','4': ArtistSel_Key(ev);
            #27: BEGIN
                   ui_ExitExclusiveMode;
                   CurUserState:=usNormal;
                   ui_TrackInfo1(cartist);
                   ui_TrackInfo2(ctitle);
                   ui_TrackInfo3(GetTrackInfo);
                   csec:=60;
                   ui_TimeInfo('--:--',shuffle);
                   ClearShufTab;
                 END;
            #13: BEGIN
                   (* Titel Gewhlt *)
                   ArtistSel_GetSelection(tmp,tmp2);
                   IF (tmp<>'') OR (tmp2<>'') THEN BEGIN
                     (* Title gewhlt *)
                     UI_GOTOXY(1,2);
                     UI_SetColors(ui_clWhite,ui_clCyan);
                     UI_WRITE('Titel hinzugefgt       ');
                     IF stopped THEN BEGIN
                       ctitle:=tmp; cartist:=tmp2;
                       PlaylistAddTitle(ctitle,cartist);
                       ui_TrackInfo1(cartist);
                       ui_TrackInfo2(ctitle);
                       csec:=60;
                       ui_TimeInfo('--:--',shuffle);
                       ctrack:=1;
                       tmp:=GetLastAvailTrack;
                       ui_TrackInfo3(GetTrackInfo);
                       Stop;
                       ClearShufTab;
                       IF tmp<>'' THEN BEGIN
                         OpenFile(tmp);
                         ui_TrackInfo1(cartist);
                         ui_TrackInfo2(ctitle);
                         ui_TrackInfo3(GetTrackInfo);
                         stopped:=FALSE;
                         paused:=FALSE;
                         Play;
                       END ELSE BEGIN
                         ui_TrackInfo1('Keine Datei verfgbar!');
                         ui_TrackInfo3('');
                         stopped:=TRUE;
                       END;
                     END ELSE BEGIN
                       (* nicht unterbrechen *)
                       PlaylistAddTitle(tmp,tmp2);
                       ui_TrackInfo3(GetTrackInfo);
                     END;
                     ArtistSel_ConfirmSelection;
                   END ELSE BEGIN
                     (* keinen Titel in der Auswahl => wie ESC *)
                     ui_ExitExclusiveMode;
                     CurUserState:=usNormal;
                     ui_TrackInfo1(cartist);
                     ui_TrackInfo2(ctitle);
                     ui_TrackInfo3(GetTrackInfo);
                     csec:=60;
                     ui_TimeInfo('--:--',shuffle);
                     ClearShufTab;
                   END;
                 END;
            '*': BEGIN (* Play *)
                   ArtistSel_GetSelection(tmp,tmp2);
                   IF (tmp<>'') OR (tmp2<>'') THEN BEGIN
                     Stop; (* fr alle Flle *)
                     ArtistSel_GetSelection(ctitle,cartist);
                     tmp:=GetTrackPath(ctitle,cartist);
                     IF tmp<>'' THEN BEGIN
                       OpenFile(tmp);
                       stopped:=FALSE;
                       paused:=FALSE;
                       Play;
                       GetStreamInfo(bitrate,samplerate,mpeg,layer);
                       tmp:='MP '+IntToStr(mpeg)+' L'+IntToStr(layer)
                           +' '+IntToStr(samplerate DIV 1000)+'kHz '
                           +IntToStr(bitrate)+'kbit/s ';
                       UI_GOTOXY(1,2);
                       UI_SetColors(ui_clWhite,ui_clBlack);
                       UI_WRITE(tmp);
                       ui_TrackInfo1(cartist);
                       ui_TrackInfo2(ctitle);
                       ui_TrackInfo3('');
                     END;
                   END;
                 END;
            '"': BEGIN (* Pause *)
                   IF NOT stopped THEN IF NOT paused THEN BEGIN
                     Pause;
                     paused:=TRUE;
                     csec:=60;
                   END;
                 END;
            '#': IF NOT stopped THEN BEGIN (* Stop *)
                   stopped:=TRUE;
                   cmin:=0;
                   csec:=60;
                   Stop;
                 END;
            #255:shutdown:=TRUE;
          END; (* CASE *)
        END;
        usPLSNameNew,usPLSNameLoad: BEGIN (* Playlisten Speichern-Dialog *)
          CASE ev OF
            'R','L','U','D','>','<': EnterName_Key(ev);
            #13: BEGIN (* Speichern *)
                   SavePlaylist(EnterName_GetName);
                   IF CurUserState=usPLSNameNew THEN BEGIN
                     CreateNewPlaylist;
                     UI_ExitExclusiveMode;
                     ui_TrackInfo1('');
                     ui_TrackInfo2('');
                     ui_TrackInfo3('');
                     ui_TimeInfo('--:--',shuffle);
                     CurUserState:=usNormal;
                     cartist:=''; ctitle:=''; ctrack:=1;
                   END ELSE IF CurUserState=usPLSNameLoad THEN BEGIN
                     PLSSel_Show;
                     CurUserState:=usPLSSelect;
                   END;
                 END;
            #27: BEGIN (* Nicht Speichern *)
                   IF CurUserState=usPLSNameNew THEN BEGIN
                     CreateNewPlaylist;
                     UI_ExitExclusiveMode;
                     ui_TrackInfo1('');
                     ui_TrackInfo2('');
                     ui_TrackInfo3('');
                     ui_TimeInfo('--:--',shuffle);
                     CurUserState:=usNormal;
                     cartist:=''; ctitle:=''; ctrack:=1;
                   END ELSE IF CurUserState=usPLSNameLoad THEN BEGIN
                     PLSSel_Show;
                     CurUserState:=usPLSSelect;
                   END;
                 END;
            #255:shutdown:=TRUE;
          END; (* CASE *)
        END;
        usPLSSelect: BEGIN (* Playlisten-Laden dialog *)
          CASE ev OF
            'R','L','U','D': PLSSel_Key(ev);
            #13: BEGIN (* Laden *)
                   Stop; stopped:=TRUE;
                   LoadPlaylist(PLSSel_GetSelection);
                   CurUserState:=usNormal;
                   cartist:=''; ctitle:=''; ctrack:=0;
                   UI_ExitExclusiveMode;
                   ui_TrackInfo1('Datei wird gesucht...');
                   ui_TrackInfo2('');
                   ui_TimeInfo('',shuffle);
                   ClearShufTab;
                   tmp:=GetNextAvailTrack;
                   ui_TrackInfo3(GetTrackInfo);
                   IF tmp<>'' THEN BEGIN
                     OpenFile(tmp);
                     ui_TrackInfo1(cartist);
                     ui_TrackInfo2(ctitle);
                     ui_TrackInfo3(GetTrackInfo);
                     stopped:=FALSE;
                     paused:=FALSE;
                     Play;
                   END ELSE BEGIN
                       ui_TrackInfo1('Keine Datei verfgbar!');
                       ui_TrackInfo3('');
                   END;
                 END;
            #27: BEGIN (* Abbruch *)
                   Stop; stopped:=TRUE;
                   CurUserState:=usNormal;
                   cartist:=''; ctitle:=''; ctrack:=0;
                   UI_ExitExclusiveMode;
                   ui_TrackInfo1('');
                   ui_TrackInfo2('');
                   ui_TrackInfo3('');
                   ui_TimeInfo('--:--',shuffle);
                   ClearShufTab;
                 END;
            #255:shutdown:=TRUE;
          END; (*CASE*)
        END;
        usPLSTitleDel: BEGIN (* Titel lschen dialog *)
          CASE ev OF
            'R','L','U','D': PLSTitleSel_Key(ev);
            #13: BEGIN (* lschen *)
                   PLSTitleSel_GetSelection(tmp,tmp2);
                   PlaylistRemoveTitle(tmp,tmp2);
                   CurUserState:=usNormal;
                   UI_ExitExclusiveMode;
                   ui_TrackInfo1(cartist);
                   ui_TrackInfo2(ctitle);
                   ui_TrackInfo3(GetTrackInfo);
                 END;
            #27: BEGIN (* Abbruch *)
                   CurUserState:=usNormal;
                   UI_ExitExclusiveMode;
                   ui_TrackInfo1(cartist);
                   ui_TrackInfo2(ctitle);
                   ui_TrackInfo3(GetTrackInfo);
                 END;
            '*': BEGIN (* Play *)
                   Stop; (* fr alle Flle *)
                   PLSTitleSel_GetSelection(ctitle,cartist);
                   tmp:=GetTrackPath(ctitle,cartist);
                   IF tmp<>'' THEN BEGIN
                     OpenFile(tmp);
                     stopped:=FALSE;
                     paused:=FALSE;
                     Play;
                   END;
                 END;
            '"': BEGIN (* Pause *)
                   IF NOT stopped THEN IF NOT paused THEN BEGIN
                     Pause;
                     paused:=TRUE;
                     csec:=60;
                   END;
                 END;
            '#': IF NOT stopped THEN BEGIN (* Stop *)
                   stopped:=TRUE;
                   cmin:=0;
                   csec:=60;
                   Stop;
                 END;
            #255:shutdown:=TRUE;
          END; (*CASE*)
        END;
        usPLSOrder: BEGIN (* Titel anordnen dialog *)
          CASE ev OF
            'R','L','U','D': PLSOrder_Key(ev);
            #13,#27: BEGIN (* Abbruch *)
                   CurUserState:=usNormal;
                   UI_ExitExclusiveMode;
                   ui_TrackInfo1(cartist);
                   ui_TrackInfo2(ctitle);
                   ui_TrackInfo3(GetTrackInfo);
                 END;
            '*': BEGIN (* Play *)
                   Stop; (* fr alle Flle *)
                   PLSOrder_GetSelection(ctitle,cartist);
                   tmp:=GetTrackPath(ctitle,cartist);
                   IF tmp<>'' THEN BEGIN
                     OpenFile(tmp);
                     stopped:=FALSE;
                     paused:=FALSE;
                     Play;
                   END;
                 END;
            '"': BEGIN (* Pause *)
                   IF NOT stopped THEN IF NOT paused THEN BEGIN
                     Pause;
                     paused:=TRUE;
                     csec:=60;
                   END;
                 END;
            '#': IF NOT stopped THEN BEGIN (* Stop *)
                   stopped:=TRUE;
                   cmin:=0;
                   csec:=60;
                   Stop;
                 END;
            #255:shutdown:=TRUE;
          END; (*CASE*)
        END;
        usPLSDelete: BEGIN (* PLS Lschen dialog *)
          CASE ev OF
            'R','L','U','D': PLSDel_Key(ev);
            #13: BEGIN (* Lschen *)
                   PlaylistDelete(PLSDEL_GetSelection);
                   CurUserState:=usNormal;
                   UI_ExitExclusiveMode;
                   ui_TrackInfo1(cartist);
                   ui_TrackInfo2(ctitle);
                   ui_TrackInfo3(GetTrackInfo);
                   ui_TimeInfo('',shuffle); csec:=60;
                 END;
            #27: BEGIN (* Abbruch *)
                   CurUserState:=usNormal;
                   UI_ExitExclusiveMode;
                   ui_TrackInfo1(cartist);
                   ui_TrackInfo2(ctitle);
                   ui_TrackInfo3(GetTrackInfo);
                   ui_TimeInfo('',shuffle); csec:=60;
                 END;
            '#': IF NOT stopped THEN BEGIN (* Stop *)
                   stopped:=TRUE;
                   cmin:=0;
                   csec:=60;
                   Stop;
                 END;
            '*': BEGIN (* Play *)
                   IF stopped THEN BEGIN
                     tmp:=GetTrackPath(ctitle,cartist);
                     IF tmp='' THEN tmp:=GetNextAvailTrack;
                     IF tmp<>'' THEN BEGIN
                       OpenFile(tmp);
                       stopped:=FALSE;
                       paused:=FALSE;
                       Play;
                     END;
                   END ELSE IF paused THEN BEGIN
                     paused:=FALSE;
                     Play;
                   END;
                 END;
            '"': BEGIN (* Pause *)
                   IF NOT stopped THEN IF NOT paused THEN BEGIN
                     Pause;
                     paused:=TRUE;
                     csec:=60;
                   END;
                 END;
            #255:shutdown:=TRUE;
          END; (*CASE*)
        END;
      END;
    END;
    IF (NOT Stopped) AND (CurUserState=usNormal) THEN BEGIN
      IF timeleft THEN BEGIN
        GetPositionLeft(nmin,nsec);
        IF (nmin<>cmin) OR (nsec<>csec) THEN BEGIN
          cmin:=nmin; csec:=nsec;
          tmp:=IntToStr(cmin)+':'; IF cmin<10 THEN tmp:='-'+tmp ELSE tmp[3]:='-';
          IF csec<10 THEN tmp:=tmp+'0';
          tmp:=tmp+IntToStr(csec);
          IF paused THEN
            ui_TimeInfoP(tmp,shuffle)
          ELSE
            ui_TimeInfo(tmp,shuffle);
        END;
      END ELSE BEGIN
        GetPosition(nmin,nsec);
        IF (nmin<>cmin) OR (nsec<>csec) THEN BEGIN
          cmin:=nmin; csec:=nsec;
          tmp:=IntToStr(cmin)+':'; IF cmin<10 THEN tmp:='0'+tmp;
          IF csec<10 THEN tmp:=tmp+'0';
          tmp:=tmp+IntToStr(csec);
          IF paused THEN
            ui_TimeInfoP(tmp,shuffle)
          ELSE
            ui_TimeInfo(tmp,shuffle);
        END;
      END;
    END;
    IF NOT stopped AND AllDataDone THEN BEGIN
      Stop;
      stopped:=TRUE;
      (* nchster Track *)
(*      IF CurUserState=usNormal THEN BEGIN*)
        (* Normal, daher nchsten spielen *)
        ui_TrackInfo1('Datei wird gesucht...');
        ui_TrackInfo2('');
        ui_TimeInfo('',shuffle);
        tmp:=GetNextAvailTrack;
        ui_TrackInfo3(GetTrackInfo);
        IF tmp<>'' THEN BEGIN
          OpenFile(tmp);
          ui_TrackInfo1(cartist);
          ui_TrackInfo2(ctitle);
          ui_TrackInfo3(GetTrackInfo);
          stopped:=FALSE;
          Play;
          paused:=FALSE;
        END;
(*      END ELSE BEGIN
        cmin:=0;
        csec:=60;
        ui_TrackInfo1('');
        ui_TrackInfo2('');
        ui_TrackInfo3('');
        ui_TimeInfo('',shuffle);
      END;*)
    END;
    if not console then IF keypressed THEN IF readkey=#27 then shutdown:=true;
  UNTIL Shutdown;
  ASSIGN(statusfile,'C:\INDEX\STATUS.INI');
  REWRITE(statusfile);
  WRITELN(statusfile,ctrack);
  IF shuffle THEN
    WRITELN(statusfile,'SHUFFLE=ON')
  ELSE
    WRITELN(statusfile,'SHUFFLE=OFF');
  IF timeleft THEN
    WRITELN(statusfile,'TIMELEFT=ON')
  ELSE
    WRITELN(statusfile,'TIMELEFT=OFF');
  CLOSE(statusfile);
  ExitMas;
  Dispose(shuftab);
  halt(123);
END;

END.
