UNIT MP3USER;
(* Userinterface-Routinen *)

INTERFACE

PROCEDURE TitleSel_Show;
PROCEDURE TitleSel_Key(key: char);
PROCEDURE TitleSel_GetSelection(VAR title,artist: STRING);
PROCEDURE TitleSel_ConfirmSelection;
PROCEDURE ArtistSel_Show;
PROCEDURE ArtistSel_Key(key: char);
PROCEDURE ArtistSel_GetSelection(VAR title,artist: STRING);
PROCEDURE ArtistSel_ConfirmSelection;
PROCEDURE EnterName_Show(name: STRING);
FUNCTION EnterName_GetName: STRING;
PROCEDURE EnterName_Key(key: CHAR);
PROCEDURE PLSSel_Show;
PROCEDURE PLSSel_Key(key: char);
FUNCTION PLSSel_GetSelection: STRING;
PROCEDURE PLSTitleSel_Show;
PROCEDURE PLSTitleSel_Key(key: char);
PROCEDURE PLSTitleSel_GetSelection(VAR title,artist: STRING);
PROCEDURE PLSOrder_Show;
PROCEDURE PLSOrder_Key(key: char);
PROCEDURE PLSOrder_GetSelection(VAR title,artist: STRING);
PROCEDURE PLSDel_Show;
PROCEDURE PLSDel_Key(key: char);
FUNCTION PLSDel_GetSelection: STRING;

IMPLEMENTATION
USES MP3PLS,MP3UICOM;

VAR CurMenuStart: LONGINT; (* Datensatz, wo Mendarst. anfngt *)
    CurMenuEnd: LONGINT;
    CurMenuLen: LONGINT; (* # Datenstze im Index *)
    PageEntryCount: BYTE; (* Zahl whlbarer Eintrge auf dieser Seite *)
    PageTitleCount: BYTE; (* Zahl der Titel auf dieser Seite *)
    PageEntryOffset: ARRAY[0..ui_RowCount] OF BYTE;
    CurPageSel: BYTE; (* Momentan gewhlter Index *)
    CurName: STRING;
    LastArtistSelected,LastTitleSelected: WORD;


PROCEDURE TitleSel_Info;

VAR ndx: FILE OF GlobalIndexRec;
    rec: GlobalIndexRec;
    tmp: string;
BEGIN
  IF CurPageSel>0 THEN BEGIN
    ASSIGN(ndx,'C:\INDEX\TITLE.IDX');
    RESET(ndx);
    SEEK(ndx,CurMenuStart+PageEntryOffset[CurPageSel]);
    READ(ndx,rec);
    tmp:=rec.data.comment;
    IF tmp<>'' THEN BEGIN
      IF LENGTH(tmp)>ui_ColCount-2 THEN tmp:=COPY(tmp,1,22);
      tmp:='['+tmp+']';
    END ELSE BEGIN
      IF LENGTH(rec.data.title)>ui_ColCount-1 THEN BEGIN
        tmp:=COPY(rec.data.title,ui_ColCount,LENGTH(rec.data.title)-ui_ColCOunt+1);
        tmp:='..'+tmp;
        IF LENGTH(tmp)>ui_ColCount THEN tmp:=COPY(tmp,1,24);
      END;
    END;
    CLOSE(ndx);
  END ELSE BEGIN
    tmp:='';
  END;
  WHILE LENGTH(tmp)<ui_ColCount DO tmp:=tmp+' ';
  UI_GOTOXY(1,2);
  UI_SetColors(ui_clWhite,ui_clBlack);
  UI_WRITE(tmp);
END;

PROCEDURE TitleSel_Page;
(* Menseite malen *)
VAR ndx: FILE OF GlobalIndexRec;
    rec: GlobalIndexRec;
    cat,tmp: STRING;
    cyp,zae: BYTE;
BEGIN
  ASSIGN(ndx,'C:\INDEX\TITLE.IDX');
  RESET(ndx);
  SEEK(ndx,CurMenuStart);
  CurMenuLen:=FileSize(ndx);
  cat:='--';
  PageEntryCount:=0;
  PageTitleCount:=0;
  UI_SetColors(ui_clWhite,ui_clBlack); (* Farben *)
  UI_CLS;
  UI_CursorOff;
  STR(CurMenuLen,tmp);
  UI_WRITE('Titelauswahl ('+tmp+'):');
  cyp:=3;
  FOR zae:=1 to ui_RowCount DO UI_UnHilite(zae);
  REPEAT
    READ(ndx,rec);
    IF MakeCompareable(rec.data.artist)<>MakeCompareable(cat) THEN BEGIN
      (* neuer Artist *)
      cat:=rec.data.artist;
      UI_GOTOXY(1,cyp);
      UI_SetColors(ui_clRed,ui_clBlack);
      tmp:=cat; IF LENGTH(tmp)>ui_ColCount THEN tmp:=COPY(tmp,1,24);
      UI_WRITE(tmp);
      INC(cyp);
    END;
    IF cyp<=ui_RowCount THEN BEGIN
      (* Titel darstellbar *)
      CurMenuEnd:=FilePos(ndx)-1;
      UI_GOTOXY(1,cyp);
      IF InPLSbyTitle(CurMenuEnd) THEN BEGIN
        (* Titel schon in Playliste *)
        ui_SetColors(ui_clLightBlue,ui_clBackground);
      END ELSE BEGIN
        (* Title whlbar *)
        UI_SetColors(100+PageEntryCount*2,101+PageEntryCount*2);
        INC(PageEntryCount);
        PageEntryOffset[PageEntryCount]:=PageTitleCount;
      END;
      tmp:=rec.data.title;
      IF LENGTH(tmp)>ui_ColCount-1 THEN tmp:=COPY(tmp,1,23);
      tmp:=' '+tmp;
      WHILE LENGTH(tmp)<ui_ColCount DO tmp:=tmp+' ';
      UI_WRITE(tmp);
      INC(cyp);
      INC(PageTitleCount);
    END;
  UNTIL (cyp>ui_RowCount) OR EOF(ndx);
  CurPageSel:=0;
  CLOSE(ndx);
END;

PROCEDURE TitleSel_Key(key: char);
(* Tastendruck-Ereignis *)
BEGIN
  key:=UpCase(key);
  CASE key OF
    'D': BEGIN (* Abwrts *)
           If CurPageSel<PageEntryCount THEN BEGIN
             UI_UnHiLite(CurPageSel);
             INC(CurPageSel);
             UI_HiLite(CurPageSel);
             TitleSel_Info;
           END ELSE IF CurMenuEnd<(CurMenuLen-1) THEN BEGIN
             (* Page Down *)
             CurMenuStart:=CurMenuStart+PageTitleCount;
             TitleSel_Page;
             IF PageEntryCount>0 THEN BEGIN
               CurPageSel:=1;
               UI_HiLite(CurPageSel);
             END;
             TitleSel_Info;
           END;
         END;
    'U': BEGIN (* Aufwrts *)
           If CurPageSel>1 THEN BEGIN
             UI_UnHiLite(CurPageSel);
             DEC(CurPageSel);
             UI_HiLite(CurPageSel);
             TitleSel_Info;
           END ELSE IF CurMenuStart>0 THEN BEGIN
             (* Page Up *)
             CurMenuStart:=CurMenuStart-6;
             IF CurMenuStart<0 THEN CurMenuStart:=0;
             TitleSel_Page;
             CurPageSel:=PageEntryCount;
             IF CurPageSel>0 THEN UI_HiLite(CurPageSel);
             TitleSel_Info;
           END;
         END;
    'R': BEGIN (* Page Abwrts *)
           IF CurMenuEnd<(CurMenuLen-1) THEN BEGIN
             (* Page Down *)
             CurMenuStart:=CurMenuStart+PageTitleCount;
             TitleSel_Page;
             IF PageEntryCount>0 THEN BEGIN
               CurPageSel:=1;
               UI_HiLite(CurPageSel);
             END;
             TitleSel_Info;
           END;
         END;
    'L': BEGIN
           IF CurMenuStart>0 THEN BEGIN
             (* Page Up *)
             CurMenuStart:=CurMenuStart-6;
             IF CurMenuStart<0 THEN CurMenuStart:=0;
             TitleSel_Page;
             CurPageSel:=PageEntryCount;
             IF CurPageSel>0 THEN UI_HiLite(CurPageSel);
             TitleSel_Info;
           END;
         END;
    '>': BEGIN (* 5 Pages Abwrts *)
           (* Page Down *)
           CurMenuStart:=CurMenuStart+30;
           IF CurMenuStart>CurMenuLen-6 THEN CurMenuStart:=CurMenuLen-6;
           IF CurMenuStart<0 THEN CurMenuStart:=0;
           TitleSel_Page;
           IF PageEntryCount>0 THEN BEGIN
             CurPageSel:=1;
             UI_HiLite(CurPageSel);
           END;
           TitleSel_Info;
         END;
    '<': BEGIN (* 5 Pages aufwrts *)
           IF CurMenuStart>0 THEN BEGIN
             (* Page Up *)
             CurMenuStart:=CurMenuStart-30;
             IF CurMenuStart<0 THEN CurMenuStart:=0;
             TitleSel_Page;
             CurPageSel:=PageEntryCount;
             IF CurPageSel>0 THEN UI_HiLite(CurPageSel);
             TitleSel_Info;
           END;
         END;
    '1': BEGIN (* Listenanfang *)
           IF CurMenuStart>0 THEN BEGIN
             CurMenuStart:=0;
             TitleSel_Page;
             IF PageEntryCount>0 THEN BEGIN
               CurPageSel:=1;
               UI_HiLite(CurPageSel);
             END;
             TitleSel_Info;
           END;
         END;
    '2': BEGIN (* Erstes Drittel *)
           IF CurMenuStart<>(CurMenuLen DIV 3) THEN BEGIN
             CurMenuStart:=CurMenuLen DIV 3;
             IF CurMenuStart<0 THEN CurMenuStart:=0;
             TitleSel_Page;
             IF PageEntryCount>0 THEN BEGIN
               CurPageSel:=1;
               UI_HiLite(CurPageSel);
             END;
             TitleSel_Info;
           END;
         END;
    '3': BEGIN (* Zweites Drittel *)
           IF CurMenuStart<>((2*CurMenuLen) DIV 3) THEN BEGIN
             CurMenuStart:=(2*CurMenuLen) DIV 3;
             IF CurMenuStart<0 THEN CurMenuStart:=0;
             TitleSel_Page;
             IF PageEntryCount>0 THEN BEGIN
               CurPageSel:=1;
               UI_HiLite(CurPageSel);
             END;
             TitleSel_Info;
           END;
         END;
    '4': BEGIN (* Listenende *)
           IF CurMenuStart<CurMenuLen-6 THEN BEGIN
             CurMenuStart:=CurMenuLen-6;
             IF CurMenuStart<0 THEN CurMenuStart:=0;
             TitleSel_Page;
             CurPageSel:=PageEntryCount;
             IF CurPageSel>0 THEN UI_HiLite(CurPageSel);
             TitleSel_Info;
           END;
         END;
  END;
END;

PROCEDURE TitleSel_GetSelection(VAR title,artist: STRING);
(* Daten der aktuellen auswahl zurckliefern *)
VAR ndx: FILE OF GlobalIndexRec;
    rec: GlobalIndexRec;
BEGIN
  IF CurPageSel>0 THEN BEGIN
    ASSIGN(ndx,'C:\INDEX\TITLE.IDX');
    RESET(ndx);
    SEEK(ndx,CurMenuStart+PageEntryOffset[CurPageSel]);
    READ(ndx,rec);
    CLOSE(ndx);
    LastTitleSelected:=CurMenuStart+PageEntryOffset[CurPageSel];
    title:=rec.data.title;
    artist:=rec.data.artist;
  END ELSE BEGIN
    title:='';
    artist:='';
  END;
END;

PROCEDURE TitleSel_ConfirmSelection;
(* Auswahl besttigt => Seite neu aufbauen *)
VAR tmpsel: BYTE;
BEGIN
  tmpsel:=CurPageSel;
  TitleSel_Page;
  IF PageEntryCount>=tmpsel THEN BEGIN
    CurPageSel:=tmpsel;
    UI_Hilite(CurPageSel);
  END ELSE IF PageEntryCount>0 THEN BEGIN
    CurPageSel:=PageEntryCount;
    UI_Hilite(CurPageSel);
  END;
  TitleSel_Info;
END;

PROCEDURE TitleSel_Show;
(* Auswahlmen nach Titel sortiert zeigen *)
VAR ndx: FILE OF GlobalIndexRec;
BEGIN
  (* Menstart auf letzte Wahl setzen *)
  ASSIGN(ndx,'C:\INDEX\TITLE.IDX');
  RESET(ndx);
  CurMenuLen:=FileSize(ndx);
  CLOSE(ndx);
  IF LastTitleSelected<CurMenuLen THEN BEGIN
    CurMenuStart:=LastTitleSelected;
  END ELSE BEGIN
    CurMenuStart:=0;
  END;
  TitleSel_Page;
  IF PageEntryCount>0 THEN BEGIN
    CurPageSel:=1;
    UI_HiLite(CurPageSel);
  END;
  TitleSel_Info;
END;

PROCEDURE ArtistSel_Info;

VAR ndx: FILE OF GlobalIndexRec;
    rec: GlobalIndexRec;
    tmp: string;
BEGIN
  IF CurPageSel>0 THEN BEGIN
    ASSIGN(ndx,'C:\INDEX\ARTIST.IDX');
    RESET(ndx);
    SEEK(ndx,CurMenuStart+PageEntryOffset[CurPageSel]);
    READ(ndx,rec);
    tmp:=rec.data.comment;
    IF tmp<>'' THEN BEGIN
      IF LENGTH(tmp)>ui_ColCount-2 THEN tmp:=COPY(tmp,1,22);
      tmp:='['+tmp+']';
    END ELSE BEGIN
      IF LENGTH(rec.data.title)>ui_ColCount-1 THEN BEGIN
        tmp:=COPY(rec.data.title,ui_ColCount,LENGTH(rec.data.title)-ui_ColCOunt+1);
        tmp:='..'+tmp;
        IF LENGTH(tmp)>ui_ColCount THEN tmp:=COPY(tmp,1,24);
      END;
    END;
    CLOSE(ndx);
  END ELSE BEGIN
    tmp:='';
  END;
  WHILE LENGTH(tmp)<ui_ColCount DO tmp:=tmp+' ';
  UI_GOTOXY(1,2);
  UI_SetColors(ui_clWhite,ui_clBlack);
  UI_WRITE(tmp);
END;

PROCEDURE ArtistSel_Page;
(* Menseite malen *)
VAR ndx: FILE OF GlobalIndexRec;
    rec: GlobalIndexRec;
    cat,tmp: STRING;
    cyp,zae: BYTE;
BEGIN
  ASSIGN(ndx,'C:\INDEX\ARTIST.IDX');
  RESET(ndx);
  SEEK(ndx,CurMenuStart);
  CurMenuLen:=FileSize(ndx);
  cat:='--';
  PageEntryCount:=0;
  PageTitleCount:=0;
  UI_SetColors(ui_clWhite,ui_clBlack); (* Farben *)
  UI_CLS;
  UI_CursorOff;
  STR(CurMenuLen,tmp);
  UI_WRITE('Titelauswahl ('+tmp+'):');
  FOR zae:=1 to ui_RowCount DO UI_UnHilite(zae);
  cyp:=3;
  REPEAT
    READ(ndx,rec);
    IF MakeCompareable(rec.data.artist)<>MakeCompareable(cat) THEN BEGIN
      (* neuer Artist *)
      cat:=rec.data.artist;
      UI_GOTOXY(1,cyp);
      UI_SetColors(ui_clRed,ui_clBlack);
      tmp:=cat; IF LENGTH(tmp)>ui_ColCount THEN tmp:=COPY(tmp,1,24);
      UI_WRITE(tmp);
      INC(cyp);
    END;
    IF cyp<=ui_RowCount THEN BEGIN
      (* Titel darstellbar *)
      CurMenuEnd:=FilePos(ndx)-1;
      UI_GOTOXY(1,cyp);
      IF InPLSbyArtist(CurMenuEnd) THEN BEGIN
        (* Title schon in Playliste *)
        UI_SetColors(ui_clLightBlue,ui_clBackground);
      END ELSE BEGIN
        (* Titel whlbar *)
        UI_SetColors(100+PageEntryCount*2,101+PageEntryCount*2);
        INC(PageEntryCount);
        PageEntryOffset[PageEntryCount]:=PageTitleCount;
      END;
      tmp:=rec.data.title;
      IF LENGTH(tmp)>ui_ColCount-1 THEN tmp:=COPY(tmp,1,23);
      tmp:=' '+tmp;
      WHILE LENGTH(tmp)<ui_ColCount DO tmp:=tmp+' ';
      UI_WRITE(tmp);
      INC(cyp);
      INC(PageTitleCount);
    END;
  UNTIL (cyp>ui_RowCount) OR EOF(ndx);
  CurPageSel:=0;
  CLOSE(ndx);
END;

PROCEDURE ArtistSel_Key(key: char);
(* Tastendruck-Ereignis *)
BEGIN
  key:=UpCase(key);
  CASE key OF
    'D': BEGIN (* Abwrts *)
           If CurPageSel<PageEntryCount THEN BEGIN
             UI_UnHiLite(CurPageSel);
             INC(CurPageSel);
             UI_HiLite(CurPageSel);
             ArtistSel_Info;
           END ELSE IF CurMenuEnd<(CurMenuLen-1) THEN BEGIN
             (* Page Down *)
             CurMenuStart:=CurMenuStart+PageTitleCount;
             ArtistSel_Page;
             IF PageEntryCount>0 THEN BEGIN
               CurPageSel:=1;
               UI_HiLite(CurPageSel);
             END;
             ArtistSel_Info;
           END;
         END;
    'U': BEGIN (* Aufwrts *)
           If CurPageSel>1 THEN BEGIN
             UI_UnHiLite(CurPageSel);
             DEC(CurPageSel);
             UI_HiLite(CurPageSel);
             ArtistSel_Info;
           END ELSE IF CurMenuStart>0 THEN BEGIN
             (* Page Down *)
             CurMenuStart:=CurMenuStart-6;
             IF CurMenuStart<0 THEN CurMenuStart:=0;
             ArtistSel_Page;
             CurPageSel:=PageEntryCount;
             IF CurPageSel>0 THEN UI_HiLite(CurPageSel);
             ArtistSel_Info;
           END;
         END;
    'R': BEGIN (* Page Abwrts *)
           IF CurMenuEnd<(CurMenuLen-1) THEN BEGIN
             (* Page Down *)
             CurMenuStart:=CurMenuStart+PageTitleCount;
             ArtistSel_Page;
             IF PageEntryCount>0 THEN BEGIN
               CurPageSel:=1;
               UI_HiLite(CurPageSel);
             END;
             ArtistSel_Info;
           END;
         END;
    'L': BEGIN
           IF CurMenuStart>0 THEN BEGIN
             (* Page Up *)
             CurMenuStart:=CurMenuStart-6;
             IF CurMenuStart<0 THEN CurMenuStart:=0;
             ArtistSel_Page;
             CurPageSel:=PageEntryCount;
             IF CurPageSel>0 THEN UI_HiLite(CurPageSel);
             ArtistSel_Info;
           END;
         END;
    '>': BEGIN (* 5 Pages Abwrts *)
           (* Page Down *)
           CurMenuStart:=CurMenuStart+30;
           IF CurMenuStart>CurMenuLen-6 THEN CurMenuStart:=CurMenuLen-6;
           ArtistSel_Page;
           IF PageEntryCount>0 THEN BEGIN
             CurPageSel:=1;
             UI_HiLite(CurPageSel);
           END;
           ArtistSel_Info;
         END;
    '<': BEGIN (* 5 Pages aufwrts *)
           IF CurMenuStart>0 THEN BEGIN
             (* Page Up *)
             CurMenuStart:=CurMenuStart-30;
             IF CurMenuStart<0 THEN CurMenuStart:=0;
             ArtistSel_Page;
             CurPageSel:=PageEntryCount;
             IF CurPageSel>0 THEN UI_HiLite(CurPageSel);
             ArtistSel_Info;
           END;
         END;
    '1': BEGIN (* Listenanfang *)
           IF CurMenuStart>0 THEN BEGIN
             CurMenuStart:=0;
             ArtistSel_Page;
             IF PageEntryCount>0 THEN BEGIN
               CurPageSel:=1;
               UI_HiLite(CurPageSel);
             END;
             ArtistSel_Info;
           END;
         END;
    '2': BEGIN (* Erstes Drittel *)
           IF CurMenuStart<>(CurMenuLen DIV 3) THEN BEGIN
             CurMenuStart:=CurMenuLen DIV 3;
             IF CurMenuStart<0 THEN CurMenuStart:=0;
             ArtistSel_Page;
             IF PageEntryCount>0 THEN BEGIN
               CurPageSel:=1;
               UI_HiLite(CurPageSel);
             END;
             ArtistSel_Info;
           END;
         END;
    '3': BEGIN (* Zweites Drittel *)
           IF CurMenuStart<>((2*CurMenuLen) DIV 3) THEN BEGIN
             CurMenuStart:=(2*CurMenuLen) DIV 3;
             IF CurMenuStart<0 THEN CurMenuStart:=0;
             ArtistSel_Page;
             IF PageEntryCount>0 THEN BEGIN
               CurPageSel:=1;
               UI_HiLite(CurPageSel);
             END;
             ArtistSel_Info;
           END;
         END;
    '4': BEGIN (* Listenende *)
           IF CurMenuStart<CurMenuLen-6 THEN BEGIN
             CurMenuStart:=CurMenuLen-6;
             IF CurMenuStart<0 THEN CurMenuStart:=0;
             ArtistSel_Page;
             CurPageSel:=PageEntryCount;
             IF CurPageSel>0 THEN UI_HiLite(CurPageSel);
             ArtistSel_Info;
           END;
         END;
  END;
END;

PROCEDURE ArtistSel_GetSelection(VAR title,artist: STRING);
(* Daten der aktuellen auswahl zurckliefern *)
VAR ndx: FILE OF GlobalIndexRec;
    rec: GlobalIndexRec;
BEGIN
  IF CurPageSel>0 THEN BEGIN
    ASSIGN(ndx,'C:\INDEX\ARTIST.IDX');
    RESET(ndx);
    SEEK(ndx,CurMenuStart+PageEntryOffset[CurPageSel]);
    READ(ndx,rec);
    CLOSE(ndx);
    LastArtistSelected:=CurMenuStart+PageEntryOffset[CurPageSel];
    title:=rec.data.title;
    artist:=rec.data.artist;
  END ELSE BEGIN
    title:=''; artist:='';
  END;
END;

PROCEDURE ArtistSel_ConfirmSelection;
(* Auswahl besttigt => Seite neu aufbauen, Auswahl anpassen *)
VAR tmpsel: BYTE;
BEGIN
  tmpsel:=CurPageSel;
  ArtistSel_Page;
  IF PageEntryCount>=tmpsel THEN BEGIN
    CurPageSel:=tmpsel;
    UI_HiLite(CurPageSel);
  END ELSE IF PageEntryCount>0 THEN BEGIN
    CurPageSel:=PageEntryCount;
    UI_HiLite(CurPageSel);
  END;
  ArtistSel_Info;
END;

PROCEDURE ArtistSel_Show;
(* Auswahlmen nach Titel sortiert zeigen *)
VAR ndx: FILE OF GlobalIndexRec;
BEGIN
  (* Menstart auf letzte Wahl setzen *)
  ASSIGN(ndx,'C:\INDEX\ARTIST.IDX');
  RESET(ndx);
  CurMenuLen:=FileSize(ndx);
  CLOSE(ndx);
  IF LastArtistSelected<CurMenuLen THEN BEGIN
    CurMenuStart:=LastArtistSelected;
  END ELSE BEGIN
    CurMenuStart:=0;
  END;
  ArtistSel_Page;
  IF PageEntryCount>0 THEN BEGIN
    CurPageSel:=1;
    UI_HiLite(CurPageSel);
  END;
  ArtistSel_Info;
END;

PROCEDURE EnterName_Key(key: CHAR);
BEGIN
  CASE key OF
    'R': IF CurPageSel<UI_ColCount THEN BEGIN (* CUrsor Rechts *)
           INC(CurPageSel);
           UI_GOTOXY(CurPageSel,5);
         END;
    'L': IF CurPageSel>1 THEN BEGIN (* CUrsor Links *)
           DEC(CurPageSel);
           UI_GOTOXY(CurPageSel,5);
         END;
    'U': BEGIN (* Zeichen rauf *)
           CurName[CurPageSel]:=CHR(ORD(CurName[CurPageSel])+1);
           IF CurName[CurPageSel]>ui_MaxASCII THEN CurName[CurPageSel]:=ui_MinASCII;
           UI_GOTOXY(CurPageSel,5);
           UI_WRITE(CurName[CurPageSel]);
           UI_GOTOXY(CurPageSel,5);
         END;
    'D': BEGIN (* Zeichen runter *)
           CurName[CurPageSel]:=CHR(ORD(CurName[CurPageSel])-1);
           IF CurName[CurPageSel]<ui_MinASCII THEN CurName[CurPageSel]:=ui_MAxASCII;
           UI_GOTOXY(CurPageSel,5);
           UI_WRITE(CurName[CurPageSel]);
           UI_GOTOXY(CurPageSel,5);
         END;
    '>': BEGIN (* A *)
           CurName[CurPageSel]:='A';
           UI_GOTOXY(CurPageSel,5);
           UI_WRITE(CurName[CurPageSel]);
           UI_GOTOXY(CurPageSel,5);
         END;
    '<': BEGIN (* a *)
           CurName[CurPageSel]:='a';
           UI_GOTOXY(CurPageSel,5);
           UI_WRITE(CurName[CurPageSel]);
           UI_GOTOXY(CurPageSel,5);
         END;
  END;
END;

FUNCTION EnterName_GetName: STRING;
BEGIN
  WHILE (CurName[Length(CurName)]=' ') AND (Length(CurName)>0) DO CurName[0]:=CHR(ORD(CurName[0])-1);
  EnterName_GetName:=CurName;
END;

PROCEDURE EnterName_Show(name: STRING);
(* Namenseingabe *)
VAR zae: BYTE;
BEGIN
  CurName:=name;
  WHILE LENGTH(CurName)<ui_ColCount DO CurName:=CurName+' ';
  UI_SetColors(ui_ClWhite,ui_ClBlack);
  UI_CLS;
  UI_GotoXY(1,1);
  UI_WRITE('Die Playliste wurde');
  UI_GotoXY(1,2);
  UI_WRITE('verndert:');
  UI_GotoXY(1,8);
  UI_WRITE(' [OK]: speichern');
  UI_GotoXY(1,9);
  UI_WRITE(' [ESC]: verwerfen');
  UI_SetColors(ui_ClGreen,ui_ClBlack);
  UI_GotoXY(1,5);
  UI_WRITE(CurName);
  UI_GotoXY(1,5);
  UI_CursorOn;
  CurPageSel:=1;
END;

PROCEDURE PLSSel_Page;
(* Menseite malen *)
VAR ndx: FILE OF PLSIndexEntry;
    rec: PLSIndexEntry;
    cat,tmp: STRING;
    cyp,zae: BYTE;
BEGIN
  ASSIGN(ndx,'C:\INDEX\PLAYLIST.IDX');
  RESET(ndx);
  SEEK(ndx,CurMenuStart);
  CurMenuLen:=FileSize(ndx);
  PageEntryCount:=0;
  UI_SetColors(ui_clWhite,ui_clBlack); (* Farben *)
  UI_CLS;
  UI_CursorOff;
  STR(CurMenuLen,tmp);
  UI_WRITE('Playliste laden ('+tmp+'):');
  FOR zae:=1 to ui_RowCount DO UI_UnHilite(zae);
  cyp:=3;
  REPEAT
    READ(ndx,rec);
    IF cyp<=ui_RowCount THEN BEGIN
      (* Titel darstellbar *)
      CurMenuEnd:=FilePos(ndx)-1;
      UI_GOTOXY(1,cyp);
      UI_SetColors(100+PageEntryCount*2,101+PageEntryCount*2);
      tmp:=rec.title;
      IF LENGTH(tmp)>ui_ColCount-1 THEN tmp:=COPY(tmp,1,24);
      WHILE LENGTH(tmp)<ui_ColCount-1 DO tmp:=tmp+' ';
      UI_WRITE(tmp);
      INC(cyp);
      INC(PageEntryCount);
    END;
  UNTIL (cyp>ui_RowCount) OR EOF(ndx);
  CurPageSel:=0;
  CLOSE(ndx);
END;

PROCEDURE PLSSel_Key(key: char);
(* Tastendruck-Ereignis *)
BEGIN
  key:=UpCase(key);
  CASE key OF
    'D': BEGIN (* Abwrts *)
           If CurPageSel<PageEntryCount THEN BEGIN
             UI_UnHiLite(CurPageSel);
             INC(CurPageSel);
             UI_HiLite(CurPageSel);
           END ELSE IF CurMenuEnd<(CurMenuLen-1) THEN BEGIN
             (* Page Down *)
             CurMenuStart:=CurMenuStart+PageEntryCount;
             PLSSel_Page;
             CurPageSel:=1;
             UI_HiLite(CurPageSel);
           END;
         END;
    'U': BEGIN (* Aufwrts *)
           If CurPageSel>1 THEN BEGIN
             UI_UnHiLite(CurPageSel);
             DEC(CurPageSel);
             UI_HiLite(CurPageSel);
           END ELSE IF CurMenuStart>0 THEN BEGIN
             (* Page up *)
             CurMenuStart:=CurMenuStart-PageEntryCount;
             IF CurMenuStart<0 THEN CurMenuStart:=0;
             PLSSel_Page;
             CurPageSel:=PageEntryCount;
             UI_HiLite(CurPageSel);
           END;
         END;
    'R': BEGIN (* Page Abwrts *)
           IF CurMenuEnd<(CurMenuLen-1) THEN BEGIN
             (* Page Down *)
             CurMenuStart:=CurMenuStart+PageEntryCount;
             PLSSel_Page;
             CurPageSel:=1;
             UI_HiLite(CurPageSel);
           END;
         END;
    'L': BEGIN
           IF CurMenuStart>0 THEN BEGIN
             (* Page Up *)
             CurMenuStart:=CurMenuStart-PageEntryCount;
             IF CurMenuStart<0 THEN CurMenuStart:=0;
             PLSSel_Page;
             CurPageSel:=PageEntryCount;
             UI_HiLite(CurPageSel);
           END;
         END;
  END;
END;

FUNCTION PLSSel_GetSelection: STRING;
(* Daten der aktuellen auswahl zurckliefern *)
VAR ndx: FILE OF PLSIndexEntry;
    rec: PLSIndexEntry;
BEGIN
  ASSIGN(ndx,'C:\INDEX\PLAYLIST.IDX');
  RESET(ndx);
  SEEK(ndx,CurMenuStart+CurPageSel-1);
  READ(ndx,rec);
  CLOSE(ndx);
  PLSSel_GetSelection:=rec.path;
END;

PROCEDURE PLSSel_Show;
(* Auswahlmen nach Titel sortiert zeigen *)
BEGIN
  CurMenuStart:=0;
  PLSSel_Page;
  CurPageSel:=1;
  UI_HiLite(CurPageSel);
END;

PROCEDURE PLSTitleSel_Page;
(* Menseite malen *)
VAR ndx: FILE OF PLSEntry;
    rec: PLSEntry;
    cat,tmp: STRING;
    cyp,zae: BYTE;
BEGIN
  ASSIGN(ndx,'C:\INDEX\CURRENT.PLS');
  RESET(ndx);
  SEEK(ndx,CurMenuStart);
  CurMenuLen:=FileSize(ndx);
  cat:='--';
  PageEntryCount:=0;
  UI_SetColors(ui_clWhite,ui_clBlack); (* Farben *)
  UI_CLS;
  UI_CursorOff;
  STR(CurMenuLen,tmp);
  UI_WRITE('Titel lschen:');
  FOR zae:=1 to ui_RowCount DO UI_UnHilite(zae);
  cyp:=3;
  REPEAT
    READ(ndx,rec);
    IF MakeCompareable(rec.artist)<>MakeCompareable(cat) THEN BEGIN
      (* neuer Artist *)
      cat:=rec.artist;
      UI_GOTOXY(1,cyp);
      UI_SetColors(ui_clRed,ui_clBlack);
      tmp:=cat; IF LENGTH(tmp)>ui_ColCount THEN tmp:=COPY(tmp,1,24);
      UI_WRITE(tmp);
      INC(cyp);
    END;
    IF cyp<=ui_RowCount THEN BEGIN
      (* Titel darstellbar *)
      CurMenuEnd:=FilePos(ndx)-1;
      UI_GOTOXY(1,cyp);
      UI_SetColors(100+PageEntryCount*2,101+PageEntryCount*2);
      tmp:=rec.title;
      IF LENGTH(tmp)>ui_ColCount-1 THEN tmp:=COPY(tmp,1,23);
      tmp:=' '+tmp;
      WHILE LENGTH(tmp)<ui_ColCount-1 DO tmp:=tmp+' ';
      UI_WRITE(tmp);
      INC(cyp);
      INC(PageEntryCount);
    END;
  UNTIL (cyp>ui_RowCount) OR EOF(ndx);
  CurPageSel:=0;
  CLOSE(ndx);
END;


PROCEDURE PLSTitleSel_Key(key: char);
(* Tastendruck-Ereignis *)
BEGIN
  key:=UpCase(key);
  CASE key OF
    'D': BEGIN (* Abwrts *)
           If CurPageSel<PageEntryCount THEN BEGIN
             UI_UnHiLite(CurPageSel);
             INC(CurPageSel);
             UI_HiLite(CurPageSel);
           END ELSE IF CurMenuEnd<(CurMenuLen-1) THEN BEGIN
             (* Page Down *)
             CurMenuStart:=CurMenuStart+PageEntryCount;
             PLSTitleSel_Page;
             CurPageSel:=1;
             UI_HiLite(CurPageSel);
           END;
         END;
    'U': BEGIN (* Aufwrts *)
           If CurPageSel>1 THEN BEGIN
             UI_UnHiLite(CurPageSel);
             DEC(CurPageSel);
             UI_HiLite(CurPageSel);
           END ELSE IF CurMenuStart>1 THEN BEGIN
             (* Page Down *)
             CurMenuStart:=CurMenuStart-6;
             IF CurMenuStart<1 THEN CurMenuStart:=1;
             PLSTitleSel_Page;
             CurPageSel:=PageEntryCount;
             UI_HiLite(CurPageSel);
           END;
         END;
    'R': BEGIN (* Page Abwrts *)
           IF CurMenuEnd<(CurMenuLen-1) THEN BEGIN
             (* Page Down *)
             CurMenuStart:=CurMenuStart+PageEntryCount;
             PLSTitleSel_Page;
             CurPageSel:=1;
             UI_HiLite(CurPageSel);
           END;
         END;
    'L': BEGIN
           IF CurMenuStart>1 THEN BEGIN
             (* Page Up *)
             CurMenuStart:=CurMenuStart-6;
             IF CurMenuStart<1 THEN CurMenuStart:=1;
             PLSTitleSel_Page;
             CurPageSel:=PageEntryCount;
             UI_HiLite(CurPageSel);
           END;
         END;
  END;
END;

PROCEDURE PLSTitleSel_GetSelection(VAR title,artist: STRING);
(* Daten der aktuellen auswahl zurckliefern *)
VAR ndx: FILE OF PLSEntry;
    rec: PLSEntry;
BEGIN
  ASSIGN(ndx,'C:\INDEX\CURRENT.PLS');
  RESET(ndx);
  SEEK(ndx,CurMenuStart+CurPageSel-1);
  READ(ndx,rec);
  CLOSE(ndx);
  title:=rec.title;
  artist:=rec.artist;
END;

PROCEDURE PLSTitleSel_Show;
(* Playlisten-Titel *)
BEGIN
  CurMenuStart:=1;
  PLSTitleSel_Page;
  CurPageSel:=1;
  UI_HiLite(CurPageSel);
END;

PROCEDURE PLSOrder_Page;
(* Menseite malen *)
VAR ndx: FILE OF PLSEntry;
    rec: PLSEntry;
    cat,tmp: STRING;
    cyp,zae: BYTE;
BEGIN
  ASSIGN(ndx,'C:\INDEX\CURRENT.PLS');
  RESET(ndx);
  SEEK(ndx,CurMenuStart);
  CurMenuLen:=FileSize(ndx);
  cat:='--';
  PageEntryCount:=0;
  UI_SetColors(ui_clWhite,ui_clBlack); (* Farben *)
  UI_CLS;
  UI_CursorOff;
  STR(CurMenuLen,tmp);
  UI_WRITE('Titel anordnen:');
  cyp:=3;
  FOR zae:=1 to ui_RowCount DO UI_UnHilite(zae);
  REPEAT
    READ(ndx,rec);
    IF MakeCompareable(rec.artist)<>MakeCompareable(cat) THEN BEGIN
      (* neuer Artist *)
      cat:=rec.artist;
      UI_GOTOXY(1,cyp);
      UI_SetColors(ui_clRed,ui_clBlack);
      tmp:=cat; IF LENGTH(tmp)>ui_ColCount THEN tmp:=COPY(tmp,1,24);
      UI_WRITE(tmp);
      INC(cyp);
    END;
    IF cyp<=ui_RowCount THEN BEGIN
      (* Titel darstellbar *)
      CurMenuEnd:=FilePos(ndx)-1;
      UI_GOTOXY(1,cyp);
      UI_SetColors(100+PageEntryCount*2,101+PageEntryCount*2);
      tmp:=rec.title;
      IF LENGTH(tmp)>ui_ColCount-1 THEN tmp:=COPY(tmp,1,23);
      tmp:=' '+tmp;
      WHILE LENGTH(tmp)<ui_ColCount-1 DO tmp:=tmp+' ';
      UI_WRITE(tmp);
      INC(cyp);
      INC(PageEntryCount);
    END;
  UNTIL (cyp>ui_RowCount) OR EOF(ndx);
  CLOSE(ndx);
END;

PROCEDURE PLSOrder_GetSelection(VAR title,artist: STRING);
BEGIN
  PLSTitleSel_GetSelection(title,artist);
END;


PROCEDURE PLSOrder_Key(key: char);
(* Tastendruck-Ereignis *)
BEGIN
  key:=UpCase(key);
  CASE key OF
    'D': BEGIN (* Eintrag Abwrts *)
           If CurPageSel<PageEntryCount THEN BEGIN
             UI_UnHiLite(CurPageSel);
             INC(CurPageSel);
             UI_HiLite(CurPageSel);
           END ELSE IF CurMenuEnd<(CurMenuLen-1) THEN BEGIN
             (* Page Down *)
             CurMenuStart:=CurMenuStart+PageEntryCount;
             PLSOrder_Page;
             CurPageSel:=1;
             UI_HiLite(CurPageSel);
           END;
         END;
    'U': BEGIN (* Eintrag Aufwrts *)
           If CurPageSel>1 THEN BEGIN
             UI_UnHiLite(CurPageSel);
             DEC(CurPageSel);
             UI_HiLite(CurPageSel);
           END ELSE IF CurMenuStart>1 THEN BEGIN
             (* Page Down *)
             CurMenuStart:=CurMenuStart-6;
             IF CurMenuStart<1 THEN CurMenuStart:=1;
             PLSOrder_Page;
             CurPageSel:=PageEntryCount;
             UI_HiLite(CurPageSel);
           END;
         END;
    'R': BEGIN (* Abwrts schieben *)
           IF (CurMenuStart+CurPageSel)<CurMenuLen THEN BEGIN
             PlaylistSwap(CurMenuStart+CurPageSel-1);
             If CurPageSel<PageEntryCount THEN BEGIN
               UI_UnHiLite(CurPageSel);
               INC(CurPageSel);
               PLSOrder_Page;
               UI_HiLite(CurPageSel);
             END ELSE IF CurMenuEnd<(CurMenuLen-1) THEN BEGIN
               (* Page Down *)
               CurMenuStart:=CurMenuStart+PageEntryCount;
               PLSOrder_Page;
               CurPageSel:=1;
               UI_HiLite(CurPageSel);
             END;
           END;
         END;
    'L': BEGIN (* Aufwrts schieben *)
           IF (CurMenuStart+CurPageSel)>2 THEN BEGIN
             PlaylistSwap(CurMenuStart+CurPageSel-2);
             If CurPageSel>1 THEN BEGIN
               UI_UnHiLite(CurPageSel);
               DEC(CurPageSel);
               PLSOrder_Page;
               UI_HiLite(CurPageSel);
             END ELSE IF CurMenuStart>0 THEN BEGIN
               (* Page Down *)
               CurMenuStart:=CurMenuStart-6;
               IF CurMenuStart<1 THEN CurMenuStart:=1;
               PLSOrder_Page;
               CurPageSel:=PageEntryCount;
               UI_HiLite(CurPageSel);
             END;
           END;
         END;
  END;
END;

PROCEDURE PLSOrder_Show;
(* Playlisten-Titel *)
BEGIN
  CurMenuStart:=1;
  PLSOrder_Page;
  CurPageSel:=1;
  UI_HiLite(CurPageSel);
END;

PROCEDURE PLSDel_Page;
(* Menseite malen *)
VAR ndx: FILE OF PLSIndexEntry;
    rec: PLSIndexEntry;
    cat,tmp: STRING;
    cyp,zae: BYTE;
BEGIN
  ASSIGN(ndx,'C:\INDEX\PLAYLIST.IDX');
  RESET(ndx);
  SEEK(ndx,CurMenuStart);
  CurMenuLen:=FileSize(ndx);
  PageEntryCount:=0;
  UI_SetColors(ui_clWhite,ui_clBlack); (* Farben *)
  UI_CLS;
  UI_CursorOff;
  STR(CurMenuLen,tmp);
  UI_WRITE('Playliste lschen:');
  FOR zae:=1 to ui_RowCount DO UI_UnHilite(zae);
  cyp:=3;
  REPEAT
    READ(ndx,rec);
    IF cyp<=ui_RowCount THEN BEGIN
      (* Titel darstellbar *)
      CurMenuEnd:=FilePos(ndx)-1;
      UI_GOTOXY(1,cyp);
      UI_SetColors(100+PageEntryCount*2,101+PageEntryCount*2);
      tmp:=rec.title;
      IF LENGTH(tmp)>ui_ColCount-1 THEN tmp:=COPY(tmp,1,24);
      WHILE LENGTH(tmp)<ui_ColCount-1 DO tmp:=tmp+' ';
      UI_WRITE(tmp);
      INC(cyp);
      INC(PageEntryCount);
    END;
  UNTIL (cyp>ui_RowCount) OR EOF(ndx);
  CurPageSel:=0;
  CLOSE(ndx);
END;

PROCEDURE PLSDel_Key(key: char);
(* Tastendruck-Ereignis *)
BEGIN
  key:=UpCase(key);
  CASE key OF
    'D': BEGIN (* Abwrts *)
           If CurPageSel<PageEntryCount THEN BEGIN
             UI_UnHiLite(CurPageSel);
             INC(CurPageSel);
             UI_HiLite(CurPageSel);
           END ELSE IF CurMenuEnd<(CurMenuLen-1) THEN BEGIN
             (* Page Down *)
             CurMenuStart:=CurMenuStart+PageEntryCount;
             PLSDel_Page;
             CurPageSel:=1;
             UI_HiLite(CurPageSel);
           END;
         END;
    'U': BEGIN (* Aufwrts *)
           If CurPageSel>1 THEN BEGIN
             UI_UnHiLite(CurPageSel);
             DEC(CurPageSel);
             UI_HiLite(CurPageSel);
           END ELSE IF CurMenuStart>0 THEN BEGIN
             (* Page up *)
             CurMenuStart:=CurMenuStart-PageEntryCount;
             IF CurMenuStart<0 THEN CurMenuStart:=0;
             PLSDel_Page;
             CurPageSel:=PageEntryCount;
             UI_HiLite(CurPageSel);
           END;
         END;
    'R': BEGIN (* Page Abwrts *)
           IF CurMenuEnd<(CurMenuLen-1) THEN BEGIN
             (* Page Down *)
             CurMenuStart:=CurMenuStart+PageEntryCount;
             PLSDel_Page;
             CurPageSel:=1;
             UI_HiLite(CurPageSel);
           END;
         END;
    'L': BEGIN
           IF CurMenuStart>0 THEN BEGIN
             (* Page Up *)
             CurMenuStart:=CurMenuStart-PageEntryCount;
             IF CurMenuStart<0 THEN CurMenuStart:=0;
             PLSDel_Page;
             CurPageSel:=PageEntryCount;
             UI_HiLite(CurPageSel);
           END;
         END;
  END;
END;

FUNCTION PLSDel_GetSelection: STRING;
(* Daten der aktuellen auswahl zurckliefern *)
VAR ndx: FILE OF PLSIndexEntry;
    rec: PLSIndexEntry;
BEGIN
  ASSIGN(ndx,'C:\INDEX\PLAYLIST.IDX');
  RESET(ndx);
  SEEK(ndx,CurMenuStart+CurPageSel-1);
  READ(ndx,rec);
  CLOSE(ndx);
  PLSDel_GetSelection:=rec.path;
END;

PROCEDURE PLSDel_Show;
(* Auswahlmen nach Titel sortiert zeigen *)
BEGIN
  CurMenuStart:=0;
  PLSDel_Page;
  CurPageSel:=1;
  UI_HiLite(CurPageSel);
END;

BEGIN
  LastArtistSelected:=0; LastTitleSelected:=0;
END.