unit PUMPI2C;
{$UNDEF FastOutput}
interface

procedure Send_Word(Dev,Adr : Byte; Dat : Word);
procedure Send_DWord(Dev,Adr : Byte; Dat1,Dat2 : Word);
FUNCTION Read_D0(Adress: WORD; VAR Dat: LONGINT): BOOLEAN;
PROCEDURE Write_D0(Adress: WORD; Dat: LONGINT);
PROCEDURE Write_D1(Adress: WORD; Dat: LONGINT);

implementation

uses crt;

procedure put_port(port : Word; dat : Byte);
begin
  asm
    mov dx,(port)
    mov al,(dat)
    out dx,al
  end;
end;

function get_port(port : Word) : Byte;
var help : Byte;
begin
  asm
    mov dx,(port)
    in  al,dx
    in  al,dx
    in  al,dx
    mov (help),al
  end;
  get_port:=help;
end;


procedure writei(reg,dat : Byte);
const strg : Array[0..5] of Byte = ($4a,$42,$48,$40,$4c,$44);(*($0a,$02,$08,$00,$0c,$04);*)
begin
  put_port($37a,strg[reg]);
  put_port($378,dat);
  put_port($37a,strg[reg]+1);
  {$IFNDEF FastOutput}
  repeat
  until get_port($379) and $80 <> 0;
  put_port($37a,strg[reg]);
  repeat
  until get_port($379) and $80 = 0;
  {$ENDIF}
end;


function readi(reg : Byte) : Byte;
const strg : Array[0..3] of Byte = ($6e,$66,$6c,$64);(*($2e,$26,$2c,$24);*)
var i,x,p : Byte;
begin
    put_port($37a,strg[reg]);
    put_port($37a,strg[reg]+1);
    repeat
      p:=get_port($379);
    until p and $80 <> 0;
    if p and $08 <> 0 then x:=1
    else x:=0;
    for i:=1 to 7 do
      begin
        put_port($37a,strg[reg]+1-4);
        repeat
          p:=get_port($379);
        until p and $80 = 0;
        put_port($37a,strg[reg]+1);
        repeat
          p:=get_port($379);
        until p and $80 <> 0;
        if p and $08 <> 0 then x:=x + (1 shl i);
      end;
    put_port($37a,strg[reg]);
    repeat
    until get_port($379) and $80 = 0;
    readi:=x;
end;


const DAT=$01;
      CLK=$02;

procedure Start;
begin
  writei(1,0);
  writei(1,DAT);
  writei(1,DAT OR CLK);
  writei(1,       CLK);
  writei(1,0);
end;

procedure Stopp;
begin
  writei(1,0);
  writei(1,       CLK);
  writei(1,DAT OR CLK);
end;

function I2CWrite(Data : Byte) : Boolean;
var i : Byte;
var c : char;
begin
  asm cli; end;
  writei(1,0);
  for i:=7 downto 0 do

    begin
      if Data and (1 shl i)=0 then
           begin
             writei(1,0);
             writei(1,CLK);
             while (ReadI(0) AND $2)=0 do;
             writei(1,0);
           end
      else begin
             writei(1,DAT);
             writei(1,DAT OR CLK);
             while (ReadI(0) AND $2)=0 do;
             writei(1,DAT);
           end;
    end;
  writei(1,DAT);
  writei(1,DAT OR CLK);
  while (ReadI(0) AND $2)=0 do;
  I2CWrite:=readi(0) and $01=0;
  writei(1,DAT);
  asm sti; end;
end;

function I2CRead: BYTE;
(* Datenbyte lesen *)
var i : Byte;
    d : Byte;
begin
  asm cli; end;
  writei(1,DAT);
  d:=0;
  for i:=7 downto 0 do begin
    writei(1,DAT);
    writei(1,DAT OR CLK);
    WHILE (ReadI(0) AND $02)=0 DO;
    IF (ReadI(0) AND $01)<>0 THEN d:=d OR (1 SHL i);
    writei(1,DAT);
  END;
  (* ACK erzeugen *)
  writei(1,0);
  writei(1,CLK);
  while (ReadI(0) AND $2)=0 do;
  writei(1,0);
  I2CRead:=d;
  asm sti; end;
end;

procedure Send_Byte(Dev,Adr,Dat : Byte);
begin
  Start;
  if I2CWrite(Dev) then
    if I2CWrite(Adr) then
      I2CWrite(Dat);
  Stopp;
end;

procedure Send_Word(Dev,Adr : Byte; Dat : Word);
begin
  Start;
  if I2CWrite(Dev) then
    if I2CWrite(Adr) then
      if I2CWrite(Hi(Dat)) then
        I2CWrite(Lo(Dat));
  Stopp;
end;

procedure Send_DWord(Dev,Adr : Byte; Dat1,Dat2 : Word);
begin
  Start;
  if I2CWrite(Dev) then
    if I2CWrite(Adr) then
      if I2CWrite(Hi(Dat1)) then
        if I2CWrite(Lo(Dat1)) then
          if I2CWrite(Hi(Dat2)) then
            I2CWrite(Lo(Dat2));
  Stopp;
end;

procedure Send_Mem(Dev,Adr : Byte; Mem,Count,Adress,Dat1,Dat2 : Word);
begin
  Start;
  if I2CWrite(Dev) then
    if I2CWrite(Adr) then
      if I2CWrite(Hi(Mem)) then
        if I2CWrite(Lo(Mem)) then
          if I2CWrite(Hi(Count)) then
            if I2CWrite(Lo(Count)) then
              if I2CWrite(Hi(Adress)) then
                if I2CWrite(Lo(Adress)) then
                  if I2CWrite(Hi(Dat1)) then
                    if I2CWrite(Lo(Dat1)) then
                      if I2CWrite(Hi(Dat2)) then
                        I2CWrite(Lo(Dat2));
  Stopp;
end;

procedure Write_D0(Adress: WORD; dat: LONGINT);
begin
  Send_Mem($3a,$68,$a000,$0001,Adress,dat AND $FFFF,(dat SHR 16) AND 15);
end;
procedure Write_D1(Adress: WORD; dat: LONGINT);
begin
  Send_Mem($3a,$68,$B000,$0001,Adress,dat AND $FFFF,(dat SHR 16) AND 15);
end;

FUNCTION Read_D0(Adress: WORD; VAR Dat: longint): BOOLEAN;
(* Speicher lesen, TRUE wenn Erfolg *)
VAR sc: BOOLEAN;
begin
  sc:=FALSE;
  Start;
  if I2CWrite($3a) then
    if I2CWrite($68) then
      if I2CWrite($E0) then
        if I2CWrite($00) then
          if I2CWrite($0) then
            if I2CWrite($1) then
              if I2CWrite(Hi(Adress)) then
                if I2CWrite(Lo(Adress)) then begin
                  Stopp;
                  Start;
                  if I2CWrite($3a) then
                    if I2CWrite($69) then begin
                      Start;
                      if I2CWrite($3b) then begin
                        Dat:=256*I2CRead;
                        Dat:=Dat+I2CRead;
                        I2CRead;
                        Dat:=Dat + 256*16* (I2CRead AND 15);
                        sc:=TRUE;
                      END;
                    END;
                END;
  Read_D0:=sc;
  Stopp;
end;

begin
(*  clrscr;
  repeat
    repeat
    until keypressed;
    c:=readkey;
    case c of
     '2' : begin
             Send_Mem ($3A,$68,$A000,$0001,$032f,$0800,$0000);
             Send_Word($3A,$68,$0fcb);
           end;
     '"' : begin
             Send_Mem ($3A,$68,$A000,$0001,$032f,$0000,$0000);
             Send_Word($3A,$68,$0fcb);
           end;
     '3' : begin
             Send_Word($3A,$6a,$0100);
{             Send_Word($3A,$6a,$0100);
             Send_Word($3A,$68,$0fcb);
             Send_Word($3A,$68,$0fcd);}
           end;
     '' : Send_Word($3A,$6a,$0000);
    end;
  until c in ['q','Q'];
{  Send_Mem ($3A,$68,$B000,$0001,$07f8,$0000,$0008);
  Send_Mem ($3A,$68,$B000,$0001,$07fb,$0000,$0008);}*)
end.
